using Microsoft.AspNetCore.Mvc;

namespace WarmupAspNetCoreWebAPI.Controllers
{
    [Route("api/[controller]")]
    [ApiController]
    public class WarmupController : ControllerBase
    {
        private static readonly string FunctionId = Guid.NewGuid().ToString().Substring(0,8);
        private static readonly string FunctionCreated = DateTime.Now.ToString("HH:mm:ss.fff");
        private static bool _isCold = true;
        
        [HttpGet]
        public async Task<string> Get()
        {
            string requestId = Guid.NewGuid().ToString().Substring(0,8); 
            if (_isCold)
            {
                Console.WriteLine($"{FunctionId} {FunctionCreated} - warming up the function");
                await Task.Delay(10000);
                _isCold = false;
                return $"{FunctionId} {FunctionCreated} {requestId} - delayed response for 10 seconds";
            }
            return $"{FunctionId} {FunctionCreated} {requestId} - was already warm";
        }
    }
}
